/**
 * \file src/cpp/libgroupingprotein/sax/peptideresultreader.h
 * \date 03/05/2023
 * \author Olivier Langella
 * \brief read peptide results
 */


/*******************************************************************************
 * Copyright (c) 2022 Olivier Langella
 *<Olivier.Langella@universite-paris-saclay.fr>.
 *
 * This file is part of GroupingProtein.
 *
 *     GroupingProtein is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     GroupingProtein is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with GroupingProtein.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/


#include <pappsomspp/processing/xml/xmlstreamreaderinterface.h>
#include "../gp_engine.h"

#pragma once

/**
 * @todo write docs
 */
class PeptideResultReader : public pappso::XmlStreamReaderInterface
{
  public:
  /**
   * Default constructor
   */
  PeptideResultReader(GpEngine *engine);

  /**
   * Destructor
   */
  ~PeptideResultReader();


  protected:
  virtual void readStream() override;

  private:
  /// GpEngine
  GpEngine *m_gpengine;
};
